'******************************************************************************
'*
'*          TouchPen
'*    Excel  "  "
'*
'*         Windows 7  XP
'*      "TouchPen " (  BDE)
'*    C:\Program Files\TouchPen\TouchPen Commander 2.0\.
'*
'*      :
strDBName = "C:\Program Files (x86)\TouchPen\TouchPen Commander 2.0\DB\"
'*
'******************************************************************************

Const xlEdgeLeft   = &H00000007
Const xlEdgeTop    = &H00000008
Const xlEdgeBottom = &H00000009
Const xlEdgeRight  = &H0000000A

Const xlHairline   = &H00000001
Const xlThin       = &H00000002
Const xlThick      = &H00000004
Const xlMedium     = &HFFFFEFD6
Const xlNone       = -4142

Const adStateClosed         = 0
Const adStateOpen           = 1
Const adStateConnecting     = 2
Const adStateExecuting      = 4
Const adStateFetching       = 8
Const adTypeBinary          = 1
Const adTypeText            = 2
Const adModeUnknown         = 0
Const adModeRead            = 1
Const adModeWrite           = 2
Const adModeReadWrite       = 3
Const adModeShareDenyRead   = 4
Const adModeShareDenyWrite  = 8
Const adModeShareExclusive  = &Hc
Const adModeShareDenyNone   = &H10
Const adReadAll             = -1
Const adSaveCreateOverWrite = 2

Const WIN1251      = "windows-1251"
Const WIN1252      = "windows-1252"

Const adCmdText = 1

Dim oConnect, oShell, oFSO

Set oShell = CreateObject("WScript.Shell")
Set oFSO = CreateObject("Scripting.FileSystemObject")

strDBPwd  = "SKTouchPen&Bob" '     -  

'      (   PDOXUSRS.NET - C:\)
On Error Resume Next
oShell.RegWrite "HKLM\SOFTWARE\Microsoft\Jet\4.0\Engines\Paradox\ParadoxNetPath", "C:\"
oShell.RegWrite "HKLM\SOFTWARE\Microsoft\Jet\4.0\Engines\Paradox\ParadoxNetStyle", "4.x"
oShell.RegWrite "HKLM\SOFTWARE\Microsoft\Jet\4.0\Engines\Paradox\ParadoxUserName", oShell.ExpandEnvironmentStrings("%username%")
On Error Goto 0

'   
strConnect = "Provider=Microsoft.Jet.OLEDB.4.0;Extended Properties=Paradox 7.x;" & _
             "Persist Security Info=False;Mode=Read;" & _
             "Data Source=" & strDBName & ";Jet OLEDB:Database Password=" & strDBPwd & ";"

'       
'strConnect = "Driver={Microsoft Paradox Driver (*.db )};DriverID=538;Fil=Paradox 5.X;" & _
'             "DefaultDir=" & strDBName & ";Dbq=" & strDBName & ";Password=" & strDBPwd & ";" & _
'             "CollatingSequence=ASCII;"

On Error Resume Next
Set oConnect = CreateObject("ADODB.Connection")
For i=1 To 3 ' 3 
  Err.Clear
  If oConnect.State = adStateClosed Then oConnect.Open(strConnect)
Next
If Err.Number Then
  '    32- 
  SysWOW64 = "SysWOW64"
  If InStr(1, WScript.Path, SysWOW64) = 0 Then
    FWScript = oShell.ExpandEnvironmentStrings("%WINDIR%") & "\" & SysWOW64 & "\" & oFSO.GetFileName(WScript.FullName)
    If oFSO.FileExists(FWScript) Then
      oShell.Exec(FWScript & " " & """" & WScript.ScriptFullName & """")
      WScript.Quit
    End If
  End If
End If
If oConnect.State = adStateClosed Then
  Call MsgBox("    ." & vbcrlf & vbcrlf & "  :" & vbcrlf & Err.Description, vbOkOnly+vbExclamation, "")
  WScript.Quit
End If
On Error Goto 0

DReport = 0
On Error Resume Next
DReport = CDate(InputBox("  : "," TouchPen",Date))
On Error Goto 0
If DReport = 0 Then
  WScript.Quit
End If

'   Excel
On Error Resume Next
Set oExcel = CreateObject("Excel.Application")
If Err.Number Then
  Call MsgBox("    Excel." & vbcrlf & "   ." & vbcrlf & vbcrlf & "  :" & vbcrlf & Err.Description, vbOkOnly+vbExclamation, "")
  WScript.Quit
End If
On Error Goto 0

oExcel.DisplayAlerts = False
oExcel.Interactive = False

'On Error Resume Next

oExcel.Workbooks.Add
oExcel.Visible = True

oExcel.StatusBar = "   ..."
x = 1

'  
With oExcel.Cells(x, 1)
  .Cells = "  "
  .Font.Size = 14
  .Font.Bold = True
End With
x = x + 1

'   
QueryTP = "SELECT * FROM TPEvents TP, Keys LTP, Users LRegister, Users LGuard" & vbCrLf & _
          "WHERE LTP.Key = TP.IDTP" & vbCrLf & _
          "and LRegister.Key = TP.KeyReg" & vbCrLf & _
          "and LGuard.Key = TP.KeyGuard" & vbCrLf

'    
QueryTP = QueryTP + "and TP.DateReg>=" & "#" & FormatDateMMDDYYYYHHMMSS(DReport) & "#"

Set TP = oConnect.Execute(QueryTP)

Do Until TP.EOF
  
  '   
  DateReg      = TP("DateReg").Value        '  ()
  IDTP         = TP("IDTP").Value           ' IDTP
  LTP          = TP("LTP.Name").Value       ' TouchPen
  KeyReg       = TP("KeyReg").Value         ' KeyReg
  LRegister    = TP("LRegister.Name").Value ' 
  KeyGuard     = TP("KeyGuard").Value       ' KeyGuard
  LGuard       = TP("LGuard.Name").Value    ' 
  PathID       = TP("PathID").Value         ' PathID
  Mode         = TP("Mode").Value           '   
  Memo         = TP("Memo").Value           ' . 
  
  LTP          = StrConv(LTP,WIN1252,WIN1251)
  LRegister    = StrConv(LRegister,WIN1252,WIN1251)
  LGuard       = StrConv(LGuard,WIN1252,WIN1251)
  
  '  :
  N            = TP("N").Value              '  
  FromN        = TP("FromN").Value          ' 
  Incidents    = TP("Incidents").Value      ' 
  UnnecessaryN = TP("UnnecessaryN").Value   '    
  Duration     = TP("Duration").Value       '  ()
  CDuration    = GetDuration(Duration)      '  (:)
  
  If IsNull(PathID) Then
    LPath = " "
    CMode = ""
  Else
    '    
    Set Path = oConnect.Execute("SELECT * FROM Pathes WHERE ID=" & PathID)
    If Not Path.EOF Then 
      LPath = Path("Name").Value            ' 
      LPath = StrConv(LPath,WIN1252,WIN1251)
    Else
      LPath = " "
    End If
    '  
    Select Case Mode
      Case 0 CMode = ""
      Case 1 CMode = "   "
      Case 2 CMode = "   "
      Case Else CMode = ""
    End Select
  End If
  
  oExcel.Cells(x, 1) = CDuration
  oExcel.Cells(x, 2) = DateReg
  oExcel.Cells(x, 3) = LTP
  oExcel.Cells(x, 4) = LRegister
  oExcel.Cells(x, 5) = LGuard
  oExcel.Cells(x, 6) = LPath
  oExcel.Cells(x, 7) = CMode
  
  With oExcel.Range(oExcel.Cells(x, 1),oExcel.Cells(x, 7))
    .Font.Size = 12
    .Font.Italic = True
    .Borders(xlEdgeBottom).Weight = xlMedium
  End With
  
  x = x + 1
  
  oExcel.StatusBar = " " & DateReg & "..."
  
  '   
  n = 1
  
  'Set cmd = CreateObject("ADODB.Command")
  'With cmd
  '  Set .ActiveConnection = oConnect
  '  .CommandType = adCmdText
  '  .CommandText = "SELECT * FROM TPREvs WHERE DateReg>=:DateReg1 and DateReg<=:DateReg2"
  '  .Parameters.Refresh
  '  .Parameters(0).Value = DateReg
  '  .Parameters(1).Value = DateReg + 1/24/60/60
  '  Set TPR = .Execute
  'End With
  
  QueryTPR = "SELECT * FROM TPREvs" & vbCrLf & _
             "WHERE DateReg>=" & "#" & FormatDateMMDDYYYYHHMMSS(DateReg) & "#" & vbCrLf & _
             "and DateReg<=" & "#" & FormatDateMMDDYYYYHHMMSS(DateReg + 1/24/60/60) & "#"
  
  Set TPR = oConnect.Execute(QueryTPR)
  
  Do Until TPR.EOF
    
    '   
    DateEv = TPR("Date").Value '   
    KeyEv  = TPR("Key").Value  ' Key
    TypeEv = TPR("Type").Value ' Type
    
    If IsNull(KeyEv) Then
      CPoint = " "
      CTComment = " "
    Else
      CPoint = ""
      CTComment = ""
      '    
      Set Point = oConnect.Execute("SELECT * FROM Keys WHERE Key='" & KeyEv & "' and IsPrBook=False")
      If Not Point.EOF Then
        CPoint = Point("Name").Value         '  
        '  
        Select Case TypeEv
          Case 6
          Case 7
          Case 8
          Case Else TypeEv = 1
        End Select
      Else
        Set Point = oConnect.Execute("SELECT * FROM Keys WHERE Key='" & KeyEv & "' and IsPrBook=True")
        If Not Point.EOF Then
          CPoint = Point("Name").Value       ' 
          TypeEv = 2
        Else
          Set Point = oConnect.Execute("SELECT * FROM Users WHERE Key='" & KeyEv & "' and IsRegister=True")
          If Not Point.EOF Then
            CPoint = Point("Name").Value     ' 
            TypeEv = 3
          Else
            Set Point = oConnect.Execute("SELECT * FROM Users WHERE Key='" & KeyEv & "' and IsRegister=False")
            If Not Point.EOF Then
              CPoint = Point("Name").Value   ' 
              TypeEv = 4
            Else
              Set Point = oConnect.Execute("SELECT * FROM Users WHERE Key='" & KeyEv & "'")
              If Not Point.EOF Then
                CPoint = Point("Name").Value ' 
                TypeEv = 5
              End If
            End If
          End If
        End If
      End If
      CPoint = StrConv(CPoint,WIN1252,WIN1251)
      '  
      Select Case TypeEv
        Case 1 CTComment = " "
        Case 2 CTComment = ""
        Case 3 CTComment = ""
        Case 4 CTComment = ""
        Case 5 CTComment = ""
        Case 6 CTComment = " "
        Case 7 CTComment = "   "
        Case 8 CTComment = "  "
        Case Else CTComment = " "
      End Select
    End If
    
    oExcel.Cells(x, 1) = n
    oExcel.Cells(x, 2) = DateEv
    oExcel.Cells(x, 3) = CPoint
    oExcel.Cells(x, 4) = CTComment
    
    x = x + 1
    n = n + 1
    
    TPR.MoveNext
  Loop
  
  '   
  n = 1
  
  QueryTPL = "SELECT * FROM TPLEvs" & vbCrLf & _
             "WHERE DateReg>=" & "#" & FormatDateMMDDYYYYHHMMSS(DateReg) & "#" & vbCrLf & _
             "and DateReg<=" & "#" & FormatDateMMDDYYYYHHMMSS(DateReg + 1/24/60/60) & "#"
  
  Set TPL = oConnect.Execute(QueryTPL)
  
  Do Until TPL.EOF
    
    '   
    KeyEv  = TPL("Key").Value  ' Key
    
    CPoint = " "
    CTComment = " "
    
    Set Point = oConnect.Execute("SELECT * FROM Keys WHERE Key='" & KeyEv & "'")
    If Not Point.EOF Then
      CPoint = Point("Name").Value '  
      CPoint = StrConv(CPoint,WIN1252,WIN1251)
    End If
    
    oExcel.Cells(x, 1) = n
    oExcel.Cells(x, 3) = CPoint
    oExcel.Cells(x, 4) = CTComment
    
    x = x + 1
    n = n + 1
    
    TPL.MoveNext
  Loop
  
  '  
  oExcel.Cells(x, 1)   = "  " & N & "  " & FromN
  oExcel.Cells(x+1, 1) = ": " & Incidents 
  oExcel.Cells(x+1, 3) = "   : " & UnnecessaryN
  
  With oExcel.Range(oExcel.Cells(x, 1),oExcel.Cells(x, 7))
    .Font.Size = 12
    .Font.Bold = True
    .Borders(xlEdgeTop).Weight = xlMedium
    .Merge
  End With
  
  With oExcel.Range(oExcel.Cells(x+1, 1),oExcel.Cells(x+1, 2))
    .Font.Size = 12
    .Font.Bold = True
    .Merge
  End With
  
  With oExcel.Range(oExcel.Cells(x+1, 3),oExcel.Cells(x+1, 4))
    .Font.Size = 12
    .Font.Bold = True
    .Merge
  End With

  x = x + 3
  
  TP.MoveNext
Loop

With oExcel.Range(oExcel.Cells(2, 1),oExcel.Cells(x, 6))
  .Columns.AutoFit()
End With

oExcel.StatusBar = ""
oExcel.Interactive = True

oConnect.Close
Set oExcel = Nothing
Set oConnect = Nothing
Set oFSO = Nothing
Set oShell = Nothing
WScript.Quit 0

Function FormatDateMMDDYYYY(D)
  FormatDateMMDDYYYY = Format2DigitString(Month(D)) & "/" & Format2DigitString(Day(D)) & "/" & Format4DigitString(Year(D))
End Function

Function FormatDateMMDDYYYYHHMMSS(D)
  FormatDateMMDDYYYYHHMMSS = Format2DigitString(Hour(D)) & ":" & Format2DigitString(Minute(D)) & ":" & Format2DigitString(Second(D)) 
  FormatDateMMDDYYYYHHMMSS = FormatDateMMDDYYYY(D) & " " & FormatDateMMDDYYYYHHMMSS
End Function

Function Format2DigitString(N)
  Format2DigitString = ""
  If N >= 10 Then
    Format2DigitString = Format2DigitString & N
  Else
    Format2DigitString = Format2DigitString & "0" & N
  End If
End Function

Function Format4DigitString(N)
  Format4DigitString = Format2DigitString(Int(N/100))
  Format4DigitString = Format4DigitString & Format2DigitString(N Mod 100)
End Function

Function StrConv(Text, SourceCharset, DestCharset)
  If IsNull(Text) Then 
    StrConv = ""
    Exit Function
  End If
  Set Stream = CreateObject("ADODB.Stream")
  With Stream
    .Type = adTypeText
    .Mode = adModeReadWrite
    .Open
    .Charset = SourceCharset
    .WriteText Text
    .Position = 0
    .Charset = DestCharset
    StrConv = .ReadText
  End With
End Function

Function GetDuration(D)
  H = Hour(D)
  M = Minute(D)
  S = Second(D)
  GetDuration = Int(D)*24+H & ":" & Format2DigitString(M)
End Function